# Network Programming

## _**Course Objectives**_

* Perform socket programming for TCP and UDP in Python without supervision.
* Understand and explain fundamental concepts of networking, at both a high level and byte level.
* View network traffic and explain what is occurring at a high level and at a byte level.
* Be able to independently gather missing information from proper sources to solve a \(socket programming\) problem.
* Be able to analyze and/or debug networking issues with Wireshark, Netcat, and Python in the absence of information.

## _**Environment**_

* The majority of the labs will use IPv4 using Python and BSD Sockets.
* We will also cover IPv6, raw sockets, and socket programming in C throughout the course.
* We will be using multiple Linux Virtual Machines to simulate a network environment.
  * \(Windows does not support BSD Sockets.\)
* If you need assistance with Linux, let us know during the labs.

#### To access the MDBook for this module, please click [here](https://39iosdev.gitlab.io/ccd-iqt/idf/network-programming/)